//---------------------------------------------------------------------------
#ifndef FNArchH
#define FNArchH
#include <windows.h>
#if defined (BUILD_DLL)
#   define DLL_EXP __declspec(dllexport)
#else
#  if defined (BUILD_APP)
#     define DLL_EXP __declspec(dllimport)
#  else
#     define DLL_EXP
#  endif
#endif

// 
#define FNA_OK  0                 //
#define FNA_SESS_CLOSED  1        // 
#define FNA_SESS_OPENED  2         //  
#define FNA_INPARAMS_ERROR  3     //   -
#define FNA_PORT_OPEN_ERROR  4    //   
#define FNA_FN_CHANGED  5         //  ,      
#define FNA_FN_ERROR  6           //    
#define FNA_FILE_ERROR  7         //    
#define FNA_ABORT  8              //   

// - "  "
typedef struct
{
  BYTE	fnState;			//  	( ,   )
  char  szFNNum[17];  		//  
  char  szRegNumKKT[21];  	// .  
  char  szINN[13];  		// 
  DWORD ulTotalDocsCount;  	// -   
  DWORD ulFirstUnsentDoc; 	//       (0 -    ; 1 -        )
} FN_STATE;

// 
//1) ,
// :
//pszComPort -  COM   
//pszAppName -   (     )
// :
//fns -   
// -  
//    FNA_INPARAMS_ERROR
//     FNA_SESS_OPENED
//      FNA_SESS_CLOSED  FNA_PORT_OPEN_ERROR
//   FNA_OK
extern "C" DWORD __stdcall DLL_EXP FNA_Open_Session(const char * pszComPort, const char * pszAppName, FN_STATE *fns);

//2)     ,
//- ,      ,   
// :
//lDocStart -   
//lDocCount - -   
//pszFileName -  
// -  
//      FNA_INPARAMS_ERROR (  -      )
//     FNA_SESS_CLOSED
//        FNA_SESS_OPENED
//  -           
//   FNA_OK
//:
//    1.0.1  lDocStart    1.      , -    FNA_INPARAMS_ERROR
//    ,    ,     .

extern "C" DWORD __stdcall DLL_EXP FNA_Start_Downloading(DWORD lDocStart, DWORD lDocCount, const char * pszFileName);

//3)  
// :
//plCurDocNum -      
//  plCurDocNum = lDocCount -     
//   FNA_Start_Downloading       
// -  
// plCurDocNum = NULL  FNA_INPARAMS_ERROR
//       FNA_Open_Session   FNA_FN_CHANGED (  )
//     FNA_SESS_CLOSED
//   FNA_OK
extern "C" DWORD __stdcall DLL_EXP FNA_GetState(DWORD *plCurDocNum);

//4)   
// :
//pszFileName -  
//nErrMessBufLen -  
// :
//pszFileName -     
//
//      FNA_INPARAMS_ERROR
//     FNA_SESS_CLOSED
//    -   
extern "C" DWORD __stdcall DLL_EXP FNA_GetLastError(char * pszErrMessBuf, WORD nErrMessBufLen);

//5)  ,
// -  
//     FNA_SESS_CLOSED
//   FNA_OK
//  -  ,   ,   ,  
//FNA_GetState        
//FNA_GetLastError   FNA_ABORT
extern "C" DWORD __stdcall DLL_EXP FNA_Abort_Downloading(void);

//6) ,
// -  
//     FNA_SESS_CLOSED
//   FNA_OK
//           
extern "C" DWORD __stdcall DLL_EXP FNA_Close_Session(void);
//---------------------------------------------------------------------------



/*
  :

1)   - FNA_Open_Session
2)    - FNA_Start_Downloading
      - 20-30      ( ,       )
3)   FNA_GetState , ,  ProgressBar     
4)      FNA_Abort_Downloading
5)    ,  FNA_GetState       
     FNA_GetLastError,        .
6)     ,  FNA_Close_Session,     !
*/
#endif




